/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 3
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


// null models get fake light by deriving a normal from the position and using that for lighting
struct NULLVERTEX
{
	float4 Position : POSITION0;
	float3 Normal : NORMAL0;
};


#ifdef VERTEXSHADER
#include "fxVSIncludes.fx"

NULLVERTEX NullVS (float3 Position : POSITION0, float3 Normal : NORMAL0)
{
	NULLVERTEX vs_out;

	vs_out.Position = GetPosition (EntityMatrix, float4 (Position * 16.0f, 1));
	vs_out.Normal = Normal;

	return vs_out;
}
#endif


#ifdef PIXELSHADER
#include "fxPSIncludes.fx"

float4 NullPS (NULLVERTEX ps_in) : COLOR0
{
	float shadedot = dot (ps_in.Normal, shadevector);
	return ApplyGammaPS (float4 (shadelight.rgb * max (shadedot + 1.0f, (shadedot * 0.2954545f) + 1.0f), shadelight.a), 1.0f);
}
#endif

